
import java.awt.*;
import java.awt.event.*;
import java.awt.image.BufferedImage;
import java.awt.image.MemoryImageSource;
import java.awt.image.PixelGrabber;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Iterator;
import java.util.Locale;

import javax.imageio.IIOImage;
import javax.imageio.ImageIO;
import javax.imageio.ImageWriteParam;
import javax.imageio.ImageWriter;
import javax.imageio.plugins.jpeg.JPEGImageWriteParam;
import javax.imageio.stream.ImageOutputStream;
import javax.swing.*;
import javax.swing.border.LineBorder;

public class JFrame1 extends JFrame implements ActionListener {

	public final int WHITE = 255*(256*(256 + 1)+1);
	public int WIDTH=320;
	public int HEIGHT=320;
	public int width0,height0;
	public double reduct;
	public int width1,height1;
	private static final long serialVersionUID = 1230444169837772400L;

	public int[][] coeff = 
			{{0,0,0,0,0,0,0},{0,0,0,0,0,0,0},{0,0,0,0,0,0,0},{0,0,0,1,0,0,0},
			{0,0,0,0,0,0,0},{0,0,0,0,0,0,0},{0,0,0,0,0,0,0},};	
	public String text1 = "";
	public String text2 = "";
	public String testImage;
	public String filPath;
	

	public JLabel l1;
	public JLabel l2;
	
	public JLabel tl1;
	public JLabel tl2;
	public JLabel tl3;
	public JLabel tl4;
	public JLabel tl5;
	public JButton b1;
	public JButton b2;
	public JButton b3;
	public JButton b4;
	
	public JButton[][] btn=new JButton[7][7];
	public JLabel[][] lbl=new JLabel[7][7];
	public JTextArea ta1;
	LineBorder lborder;
	
	JRadioButton[] radio=new JRadioButton[2];;
	ButtonGroup group;
	
	
	public Graphics g1;
	public Graphics g2;
	
	public int[] pxl1,pxl2;
	public int red,green,blue;
	public int alpha=255;
	public int sign=1;
	public int nc=7;
	public String fname,fname1,fname2;
	public String filname1,filname2;
	public String[] nameAry;

	public static void main(String[] args){
		new JFrame1("フィルター実験");
	}
	
	public JFrame1(String title)  {

		super(title);
		setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		BufferedImage image1 = new BufferedImage(WIDTH,HEIGHT,BufferedImage.TYPE_4BYTE_ABGR); 
		BufferedImage image2 = new BufferedImage(WIDTH,HEIGHT,BufferedImage.TYPE_4BYTE_ABGR); 
		pxl1 = new int[WIDTH*HEIGHT];
		pxl2 = new int[WIDTH*HEIGHT];
		int lx = 20;
		int ly = 50;
		int ls = 510;
		int lw = WIDTH;
		int lh = HEIGHT;
		
		int bx = 530;
		int by = 400;
		int bs = 60 ;
		int bw = 150;
		int bh = 40;
		
		int tlx = 20;
		int tly = 20;
		int tls = 510;
		int tlw = 150;
		int tlh = 20;
		

		int tx = 20;
		int ty = 400;
		int tw = WIDTH;
		int th = 200;
		

		JPanel p1 = new JPanel();
		p1.setLayout(null);
		setCanvas(WIDTH, HEIGHT, image1, g1);
		
		for (int y=0; y<nc; y++){
			for (int x=0; x<nc; x++){				
				lbl[x][y]=new JLabel();
				lbl[x][y].setBounds(x*21+360,y*21+ly,20,20);
				lborder = new LineBorder(Color.black, 1, true);
				lbl[x][y].setBorder(lborder);
				lbl[x][y].setHorizontalAlignment(JLabel.CENTER);
				if (coeff[x][y]<0) {
					lbl[x][y].setForeground(Color.red);
				} else {
					lbl[x][y].setForeground(Color.black);
				}
				lbl[x][y].setText(String.valueOf(coeff[x][y]));
				
				btn[x][y]=new JButton();
				btn[x][y].setBounds(x*21+360,y*21+ly+175,20,20);
				p1.add(btn[x][y]);
				btn[x][y].addActionListener(this);
				p1.add(lbl[x][y]);
			}
		}


		l1 = new JLabel(new ImageIcon(image1));
		l1.setBounds(lx,ly,lw, lh);
		p1.add(l1);

		setCanvas(WIDTH, HEIGHT, image2, g2);
		l2 = new JLabel(new ImageIcon(image2));
		l2.setBounds(lx+ls, ly,lw, lh);
		p1.add(l2);

		tl1 = new JLabel();
		tl1.setBounds(tlx, tly, tlw, tlh);
		tl1.setText("[原画像]");
		p1.add(tl1);

		tl2 = new JLabel();
		tl2.setBounds(tlx+tls, tly, tlw, tlh);
		tl2.setText("[処理画像]");
		p1.add(tl2);
		
		tl3 = new JLabel();
		tl3.setBounds(tlx+lw+65, tly, tlw, tlh);
		tl3.setText("[フィルタ]");
		p1.add(tl3);
		
		tl4 = new JLabel();
		tl4.setBounds(tlx+lw+30, tly+180, tlw, tlh);
		tl4.setText("[フィルタ設定ボタン]");
		p1.add(tl4);
		
		JPanel p2=new JPanel();
		p2.setBounds(lx+lw+30, by, 100, 100);
		tl5 = new JLabel();
		tl5.setText("[フィルタ値符号]");
		p2.add(tl5);
	    radio[0] = new JRadioButton("＋", true);
	    radio[1] = new JRadioButton("－");

	    group = new ButtonGroup();
	    group.add(radio[0]);
	    group.add(radio[1]);
	   

	    p2.add(radio[0]);
	    p2.add(radio[1]);

	    p1.add(p2);

		b1 = new JButton("画像を開く");
		b1.setBounds(bx, by, bw, bh);
		b1.addActionListener(this);
		p1.add(b1);

		
		b2 = new JButton("フィルタ処理実行");
		b2.setBounds(bx, by+bs, bw, bh);
		b2.addActionListener(this);
		p1.add(b2);
		
		b3 = new JButton("フィルタを開く");
		b3.setBounds(bx+bw+20, by, bw, bh);
		b3.addActionListener(this);
		p1.add(b3);

		
		b4 = new JButton("フィルタを保存");
		b4.setBounds(bx+bw+20, by+bs, bw, bh);
		b4.addActionListener(this);
		p1.add(b4);

	
		ta1 = new JTextArea("");
		JScrollPane sc1 = new JScrollPane();
		sc1.setViewportView(ta1);
		sc1.setBounds(tx, ty, tw, th);
		p1.add(sc1);
		
		
		getContentPane().add(p1, BorderLayout.CENTER);

		addWindowListener(new WindowClosing() );
	    setVisible(true);
	    setExtendedState(JFrame.MAXIMIZED_BOTH);
	}
	
	public void actionPerformed(ActionEvent e) {
		if(e.getSource() == b1){
			//画像の選択		
			ta1.setText("");
			
			text1 = "";
			
			String testImage = "";
			
			JFileChooser fc = new JFileChooser( "." );
			int result = fc.showOpenDialog( null );
			if(result==JFileChooser.APPROVE_OPTION) {
				testImage = fc.getSelectedFile().getPath();
			}
			if(result==JFileChooser.CANCEL_OPTION) {
				//ta1.setText("画像の読み込みを取り消しました");
				return;
			}
			if(result==JFileChooser.ERROR_OPTION) {
				//ta1.setText( "画像が開けません" );
				return;
			}
			fname=fc.getSelectedFile().getName();
			
			text1="原画像ファイル="+fname+"\n";
			BufferedImage image0 = null;
			try {image0 = ImageIO.read(new File(testImage));}
			catch (Exception e1) { e1.printStackTrace(); image0 = null;}
			
			width0 = image0.getWidth();
			height0 = image0.getHeight();
			text1+="原画像ファイル名="+fname+"\n";
			text1+="横幅="+width0+"ピクセル,　高さ="+height0+"ピクセル\n";
			if (width0<=320 && height0<=320) l1.setIcon(new ImageIcon(image0));
			
			if (width0>height0) {
				width1=320;
				reduct=(double)width1/(double)width0;
				height1=(int)((double)height0*reduct);
				
			}
			if (width0<height0) {
				height1=320;
				reduct=(double)height1/(double)height0;
				width1=(int)((double)width0*reduct);
				
			}
			if (width0==height0) {
				width1=320; height1=320;
				reduct=1.0;
			}
			//画像のリサイズ
			text1+="リサイズ　横幅="+width1+"、高さ="+height1+"\n";
			
			BufferedImage image1 = new BufferedImage(width1, height1, image0.getType());
			// ここからリサイズ処理
			image1.getGraphics().drawImage(
	                  image0.getScaledInstance(width1, height1, Image.SCALE_AREA_AVERAGING), 
	                    0, 0, width1, height1, null);
			// ここまでリサイズ処理
			
			nameAry=fname.split("\\.");
			fname1=nameAry[0]+"_1."+nameAry[1];
			text1+="リサイズ画像ファイル名="+fname1+"\n";
			
			try {
				
				  ImageIO.write(image1, nameAry[1], new File(fname1));
				} catch (Exception e1) {
				  e1.printStackTrace();
				}

			PixelGrabber pg = new PixelGrabber(image1 , 0, 0 , width1, height1,pxl1,0,width1);
			try { pg.grabPixels(); }
			catch (InterruptedException e2) {
				text1 += e2.toString()+"\n";
			}		
			l1.setIcon(new ImageIcon(image1));
			
			ta1.setText(text1);
		} else if(e.getSource() == b2){
			
			text1+="フィルタを使用\n";

			for (int i = 0; i < WIDTH*HEIGHT; i++) pxl2[i] = 0;
			
			int dt=3,n=7;
			double sum=0;
			
			for (int j=0; j<n; j++){
				for (int i=0; i<n; i++){
					sum+=coeff[i][j];
					text1+="["+coeff[i][j]+"]";
					if (i<n-1) text1+=","; else text1+="\n";
				}
			}
			
			for (int y = dt; y < height1-dt; y++){
				for (int x = dt; x < width1-dt; x++){
					double red1=0;
					double green1=0;
					double blue1=0;

					for (int j=0; j<n; j++){
						for (int i=0; i<n;i++){
							red=getRed(x+i-dt,y+j-dt);
							green=getGreen(x+i-dt,y+j-dt);
							blue=getBlue(x+i-dt,y+j-dt);
							red1+=red*coeff[i][j];
							green1+=green*coeff[i][j];
							blue1+=blue*coeff[i][j];
						}
					}
					double br;
					if (sum!=0) br=1/sum; else br=1; 
					red=(int)(red1*br);green=(int)(green1*br);blue=(int)(blue1*br);
					if (red>255) red=255;
					if (green>255) green=255;
					if (blue>255) blue=255;
					if (red<0) red=0;
					if (green<0) green=0;
					if (blue<0) blue=0;
					pxl2[x+y*width1]=blue+green*256+red*256*256+alpha*256*256*256;
				}
			}
			
			MemoryImageSource producer = new MemoryImageSource(width1, height1, pxl2, 0, width1);
			Image image3 = createImage(producer);
			BufferedImage bi = new BufferedImage(width1, height1, BufferedImage.TYPE_4BYTE_ABGR);
			Graphics g3 = bi.createGraphics();
			g3.drawImage(image3, 0, 0, null);
			g3.dispose();
			l2.setIcon(new ImageIcon(image3));
			fname2=nameAry[0]+"_2."+nameAry[1];
			text1+="フィルタ処理画像ファイル名="+fname2+"\n";
			try {
				  ImageIO.write(bi, nameAry[1], new File(fname2));
				} catch (Exception e1) {
				  e1.printStackTrace();
				}
			
			text1+="フィルタ処理完了しました。";
			ta1.setText(text1);
		} else if(e.getSource() == b3){
			//フィルタを開く		

			JFileChooser fc1 = new JFileChooser( "." );
			int result = fc1.showOpenDialog( null );
			if(result==JFileChooser.APPROVE_OPTION) {
				filPath = fc1.getSelectedFile().getPath();
			}
			if(result==JFileChooser.CANCEL_OPTION) {
				//ta1.setText("フィルタの読み込みを取り消しました");
				return;
			}
			if(result==JFileChooser.ERROR_OPTION) {
				//ta1.setText( "フィルタが開けません" );
				return;
			}
			filname1=fc1.getSelectedFile().getName();
			
			text1+="使用フィルタファイル名="+filname1+"\n";
			
			String str;
			try {
				File f = new File(filname1);
				BufferedReader in=new BufferedReader(new FileReader(f));
				for (int j=0; j<nc; j++){
					for (int i=0; i<nc; i++){
						str=in.readLine();
						coeff[i][j]=Integer.valueOf(str);
						lbl[i][j].setText(String.valueOf(str));
					}
				}
				in.close();
			} catch (IOException e1) {
				text1+=e1.toString();
			}
			text1+="フィルタ読み込み完了\n";
			ta1.setText(text1);						
		} else if(e.getSource() == b4){
			//フィルタを保存		

			JFileChooser fc2 = new JFileChooser( "." );
			int result = fc2.showSaveDialog( null );
			if(result==JFileChooser.APPROVE_OPTION) {
				filPath = fc2.getSelectedFile().getPath();
			}
			if(result==JFileChooser.CANCEL_OPTION) {
				//ta1.setText("フィルタの保存を取り消しました");
				return;
			}
			if(result==JFileChooser.ERROR_OPTION) {
				//ta1.setText( "フィルタを保存できません" );
				return;
			}
			filname2=fc2.getSelectedFile().getName();
			
			text1+="使用フィルタファイル名="+filname2+"\n";
			
			try {
				File f = new File(filname2);
				BufferedWriter out=new BufferedWriter(new FileWriter(f));
				for (int j=0; j<nc; j++){
					for (int i=0; i<nc; i++){
						out.write(String.valueOf(coeff[i][j]));
						out.newLine();
					}
				}
				out.close();
			} catch (IOException e2) {
				text1+=e2.toString();
			}
			text1+="フィルタ保存完了\n";
			ta1.setText(text1);												
		} else {
			for (int y=0; y<7; y++){
				for (int x=0; x<7; x++){
					if (e.getSource()==btn[x][y]){
						if (radio[0].isSelected()) sign=1; else sign=-1;
						coeff[x][y]+=sign;
						if (coeff[x][y]<0) {
							lbl[x][y].setForeground(Color.red);
						} else {
							lbl[x][y].setForeground(Color.black);
						}
						lbl[x][y].setText(String.valueOf(coeff[x][y]));					
					}
				}
			}
		}
	}
	
	
	public void setCanvas(int width, int height, BufferedImage img, Graphics g){		
		
		g = img.createGraphics();
		g.setColor(Color.BLACK);
		g.drawRect(0,0,width-1, height-1);		
		
	}

	public void getPixel(int x, int y){
		int pixel = pxl1[x + y * width1];
        red = pixel >> 16 & 255;
        green = pixel >> 8 & 255;
        blue = pixel & 255;
 		return;
	}
	
	public int getRed(int x, int y){
		return pxl1[x+y*width1] >> 16 & 255;
	}
	
	public int getGreen(int x, int y){
		return pxl1[x+y*width1] >> 8 & 255;
	}
	
	public int getBlue(int x, int y){
		return pxl1[x+y*width1] & 255;
	}
	
	public class WindowClosing extends WindowAdapter{
		public void windowClosing(WindowEvent e){
			int ans = JOptionPane.showConfirmDialog(JFrame1.this, "終了しますか？");
			if (ans == JOptionPane.YES_OPTION){
				System.exit(0);  
			}
		}
	}
}
